#ifndef FOCUSEDCOLUMNLSTM__H
#define FOCUSEDCOLUMNLSTM__H

#include <torch/torch.h>
#include "Submodule.hpp"
#include "LSTM.hpp"

class FocusedColumnLSTMImpl : public torch::nn::Module, public Submodule
{
  private :

  LSTM lstm{nullptr};
  std::vector<int> focusedBuffer, focusedStack;
  std::string column;
  int maxNbElements;

  public :

  FocusedColumnLSTMImpl(std::vector<int> focusedBuffer, std::vector<int> focusedStack, std::string column, int maxNbElements, int embeddingsSize, int outEmbeddingsSize, LSTMImpl::LSTMOptions options);
  torch::Tensor forward(torch::Tensor input);
  std::size_t getOutputSize() override;
  std::size_t getInputSize() override;
  void addToContext(std::vector<std::vector<long>> & context, Dict & dict, const Config & config) const override;
};
TORCH_MODULE(FocusedColumnLSTM);

#endif

